<?php

namespace Drupal\user_discount_code\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

class MessageSettings extends ConfigFormBase {

  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return ['userDiscountCode.settings'];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'userDiscountCodeSettings';
  }

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    $config = $this->config('userDiscountCode.settings');

    $form['help_text'] = [
      '#type' => 'item',
      '#title' => 'Help',
      '#markup' => 'Use [discount:username] to show user name and [discount:discount-code] to show code.',
    ];
    $form['title'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Title'),
      '#default_value' => $config->get('title'),
    ];
    $form['message'] = [
      '#type' => 'textfield',
      '#title' => $this->t('Message'),
      '#default_value' => $config->get('message'),
    ];

    return parent ::buildForm($form, $form_state); // TODO: Change the autogenerated stub
  }

  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    \Drupal ::configFactory()->getEditable('userDiscountCode.settings')
    ->set('title', $form_state->getValue('title'))
    ->set('message', $form_state->getValue('message'))
    ->save();
    parent ::submitForm($form, $form_state); // TODO: Change the autogenerated stub
  }

  /**
   * {@inheritdoc}
   */
  public function validateForm(array &$form, FormStateInterface $form_state) {
    parent ::validateForm($form, $form_state); // TODO: Change the autogenerated stub
  }
}